---
title: TypedArray.prototype.fill()
slug: Web/JavaScript/Reference/Global_Objects/TypedArray/fill
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Prototype
  - TypedArray
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>fill()</code></strong> method fills all the elements of a typed array from a start index to an end index with a static value. This method has the same algorithm as {{jsxref("Array.prototype.fill()")}}. <em>TypedArray</em> is one of the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array types</a> here.</p>

<div>{{EmbedInteractiveExample("pages/js/typedarray-fill.html","shorter")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>typedarray</var>.fill(<var>value</var>[, <var>start = 0</var>[, <var>end = this.length</var>]])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>value</var></code></dt>
 <dd>Value to fill the typed array with.</dd>
 <dt><code><var>start</var></code> {{optional_inline}}</dt>
 <dd>Start index. Defaults to 0.</dd>
 <dt><code><var>end</var></code> {{optional_inline}}</dt>
 <dd>End index (not included). Defaults to <code>this.length</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The modified array.</p>

<h2 id="Description">Description</h2>

<p>The elements interval to fill is [<code><var>start</var></code>, <code><var>end</var></code>).</p>

<p>The <strong><code>fill()</code></strong> method takes up to three arguments <code><var>value</var></code>, <code><var>start</var></code><code><var>start</var></code> and <code><var>end</var></code>. The <code><var>start</var></code> and <code><var>end</var></code> arguments are optional with default values of <code>0</code> and the <code>length</code> of the <code>this</code> object.</p>

<p>If <code><var>start</var></code> is negative, it is treated as <code>length+start</code> where <code>length</code> is the length of the array. If <code><var>end</var></code> is negative, it is treated as <code>length+end</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_fill">Using fill()</h3>

<pre class="brush: js notranslate">new Uint8Array([1, 2, 3]).fill(4);         // Uint8Array [4, 4, 4]
new Uint8Array([1, 2, 3]).fill(4, 1);      // Uint8Array [1, 4, 4]
new Uint8Array([1, 2, 3]).fill(4, 1, 2);   // Uint8Array [1, 4, 3]
new Uint8Array([1, 2, 3]).fill(4, 1, 1);   // Uint8Array [1, 2, 3]
new Uint8Array([1, 2, 3]).fill(4, -3, -2); // Uint8Array [4, 2, 3]
</pre>

<h2 id="Polyfill">Polyfill</h2>

<p>Since there is no global object with the name <em>TypedArray</em>, polyfilling must be done on an "as needed" basis. Use the following "polyfill" along with the {{jsxref("Array.prototype.fill()")}} polyfill.</p>

<pre class="brush: js notranslate">// https://tc39.github.io/ecma262/#sec-%typedarray%.prototype.fill
if (!Uint8Array.prototype.fill) {
  Uint8Array.prototype.fill = Array.prototype.fill;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-%typedarray%.prototype.fill', 'TypedArray.prototype.fill')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.TypedArray.fill")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.fill()")}}</li>
</ul>
